# -*- coding: utf-8 -*-
from setuphelpers import *
from setupdevhelpers import *

def update_package():
    package_updated = False
    proxies = get_proxies()
    if not proxies:
        proxies = get_proxies_from_wapt_console()
    app_name = control.name

    base_url = "https://releases.pagure.org/virt-viewer/"
    windows_search = "?C=M;O=D"

    for link in bs_find_all(base_url + windows_search, 'a', 'href'):
        text = link.string
        if text.startswith("virt-viewer-x64") and text.endswith(".msi"):
            latest_bin = link['href']
            version = latest_bin.rsplit('-')[-2]
            download_url = base_url + latest_bin
            break

    # Downloading latest binaries
    print(f"Latest {app_name} version is: {version}")
    print(f"Download URL is: {download_url}")
    if not isfile(latest_bin):
        print(f"Downloading: {latest_bin}")
        wget(download_url, latest_bin, proxies=proxies)
    else:
        print(f"Binary is present: {latest_bin}")

    for f in glob.glob("*.msi"):
        if f != latest_bin:
            remove_file(f)

    # Changing version of the package
    if Version(version) > Version(control.get_software_version()):
        print(f"Software version updated (from: {control.get_software_version()} to: {version})")
        package_updated = True
    else:
        print(f"Software version up-to-date ({version})")

    control.set_software_version(get_version_from_binary(latest_bin))
    control.save_control_to_wapt()

    # Validating or not update-package-sources
    return package_updated